////////////////////////////////////////////////////////////////////////////
// Swavet.cxx: Implementation of SwavetC and SwavetCall
////////////////////////////////////////////////////////////////////////////

#include "S.h"
#include "sconnect.h"
#include "Swavet.h"

////////////////////////////////////////////////////////////////////////////
// SwavetC() - SPLUS-interface via .C() 
// 
// See the "S-PLUS Programer's Guide" for details on how the interface works.
// See Swavet.ssc for implementation of the S function that calls SwavetC()
////////////////////////////////////////////////////////////////////////////

//void SwavetC(double* pdX, double* pdY, long* plLen)
//{
//void Scwt_morlet(float *Rinput,float *Iinput,double *Oreal,
 //  double *Oimage,int *pnboctave,int *pnbvoice,
  // int *pinputsize,float *pcenterfrequency)
/*{	

		S_EVALUATOR
	int nboctave, nbvoice, i, j, k, inputsize;
  float centerfrequency, a;
  double *Ri2, *Ri1, *Ii1, *Ii, *Ri;


  centerfrequency = *pcenterfrequency;
  nboctave = *pnboctave;
  nbvoice = *pnbvoice;
  inputsize = *pinputsize;
  if(!(Ri2 = (double *)malloc(sizeof(double) * inputsize)))
    error("Memory allocation failed for Ri2 in cwt_morlet.c \n");
  if(!(Ri1 = (double *)malloc(sizeof(double) * inputsize)))
    error("Memory allocation failed for Ri1 in cwt_morlet.c \n");
  if(!(Ii1 = (double *)malloc(sizeof(double) * inputsize)))
    error("Memory allocation failed for Ii1 in cwt_morlet.c \n");
  if(!(Ri = (double *)malloc(sizeof(double) * inputsize)))
    error("Memory allocation failed for Ri in cwt_morlet.c \n");
  if(!(Ii = (double *)malloc(sizeof(double) * inputsize)))
    error("Memory allocation failed for Ii in cwt_morlet.c \n");

  for(i = 0; i < inputsize; i++) 
  {
    Ri[i] = (double)Rinput[i]; 
    Ii[i] = (double)Iinput[i];
  }

  double_fft(Ri1,Ii1,Ri,Ii,inputsize,-1);   
  
  for(i = 1; i <= nboctave; i++) 
  {
    for(j=0; j < nbvoice; j++) 
	{
      a = (float)(pow((double)2,(double)(i+j/((double)nbvoice))));
      morlet_frequency(centerfrequency,a,Ri2,inputsize); 
      multi(Ri1,Ii1,Ri2,Oreal,Oimage,inputsize);
      double_fft(Oreal,Oimage,Oreal,Oimage,inputsize,1); 
      Oreal = Oreal + inputsize;
      Oimage = Oimage + inputsize;  
    }
  }

  free((char *)Ri2);
  free((char *)Ri1);
  free((char *)Ii1);
  free((char *)Ri);
  free((char *)Ii);
}

*/



////////////////////////////////////////////////////////////////////////////
// SwavetDotCall() - SPLUS-interface via .Call() 
// 
// WARNING: SwavetCall() must return a valid s_object pointer.
// See the "S-PLUS Programer's Guide" for details on how the interface works.
// See Swavet.ssc for implementation of the S function that calls SwavetCall()
////////////////////////////////////////////////////////////////////////////

s_object* SwavetCall(s_object* ps_x)
{
	S_EVALUATOR
	s_object* ps_y = blt_in_NULL; //initialize to the build-in NULL object

  // TODO: Replace the example code below with your own code.

	//Validate and get pointer to the "numeric" object
  if((ps_x == NULL) || (!IS_NUMERIC(ps_x)))
    PROBLEM "Invalid input" ERROR;
	double* pdX = NUMERIC_POINTER(ps_x); 

	//Create the returned object.
	long len = LENGTH(ps_x);
	ps_y = NEW_NUMERIC(len); 
  if(ps_y == NULL) 
    PROBLEM "Fail to allocate memory using NEW_NUMERIC" ERROR;
	double* pdY = NUMERIC_POINTER(ps_y);

	//Perform element by element operation
	for(long n=0; n< len; n++)
		pdY[n] = pdX[n] * pdX[n]; //The output = the input squared

	return ps_y;
}

////////////////////////////////////////////////////////////////////////////
// SwavetCall2() - same as SwavetCall but use C++ classes from sconnect library
// See Swavet.ssc for implementation of the S function that calls SwavetCall2()
////////////////////////////////////////////////////////////////////////////

s_object* SwavetCall2(s_object* ps_x)
{
	S_EVALUATOR

	CSPobject sValue;

	// TODO: Replace the example code below with your own code.

	try
	{
		//Wrap a C++ object around the input argument.
		//The constructor performs validation, increments reference count
		//and throws exception if there is any error.
		CSPnumeric x(ps_x); 

		//Perform element by element operation and
		//create the returned object with the same "S" class as x.
		sValue = x * x; //The output = the input squared

	}
	catch(...)
	{
		sValue = blt_in_NULL; //the build-in NULL object.
	}

	return sValue.Detach(); //return the S object detached from C++ wrapper.
}







